# Written by Bram Cohen
# see LICENSE.txt for license information

from random import randrange
##################################################################
#Modified: Sun Jul 27, 10:30, Karthik
#Purpose: import time for the time stamp in the ip_peer_cache
from time import time
#End Modify - Karthik
##################################################################
true = 1
false = 0

class Choker:
##################################################################
#Modified: Sun Jul 27, 03:21, Karthik
#Purpose: pass aditional parameter , piece length to choker class.
#    def __init__(self, config, schedule,done = lambda: false):
    def __init__(self, config, schedule, piece_length, done = lambda: false):
#End Modify - Karthik
##################################################################
        self.config = config
        self.schedule = schedule
        self.connections = []
        self.count = 0
        self.done = done
##################################################################
#Modified: Sat Jul 26, 21:14, Karthik
#Purpose: Adding dictionary of unique_ips. The declaration follows.
	self.unique_ips = {}
#Purpose: The optimistic trade bandwidth is 1/10th the max_upload_bandwidth
#in case of seed, allocate the entire bandwidth to upload.
	self.total_optimistic_rate=config['max_upload_rate']/10
#Purpose: Set piece length
	self.piece_length=piece_length
#Purpose: Add dictionary for maintaining ip_peer_cache
	self.ip_peer_cache={}
#End Modify - Karthik
##################################################################
##################################################################
#Modified: Sun Jul 27, 01:51, Karthik
#Purpose: schedule the function to distribute credit every 5 seconds.
	schedule(self._distribute_credit,5)
#Purpose: Refresh ip_peer_cache.
	schedule(self._refresh_cache,21600)#6 hours
#End Modify - Karthik
##################################################################
##################################################################
#Modified: Monday, July 28 2003, 19:28, Karthik
#Purpose: integreated round_robin functionality in _rechoke itself._rechoke called by distribute_credit.
#        schedule(self._round_robin, 10)
#End Modify - Karthik
##################################################################


##################################################################
#Modified: Sun Jul 27, 10:51, Karthik
#Purpose: drop outdated entries(1 day) from ip cache every 6 hours 
    def _refresh_cache(self):
	self.schedule(_refresh_cache,21600)
	print "Refreshing ip peer cache"
	for ipaddr,timestamp in self.ip_peer_cache.items():
	    if timestamp + 86400 < time():# delete more than a day old (24-30 hours)
		del(self.ip_peer_cache[ipaddr])
#End Modify - Karthik
##################################################################

##################################################################
#Modified: Sun Jul 27, 10:51, Karthik
#Purpose: return whether or not to give free credit.
    def is_first_time_for_free_credit(self,connection):
	if connection.get_ip() in self.ip_peer_cache.keys():
	    return false
	else:
	    return true	
#End Modify - Karthik
##################################################################

##################################################################
#Modified: Sat Jul 26, 21:14, Karthik
#Purpose: distribute credit every 5 seconds.
    def _distribute_credit(self):	
	self.schedule(self._distribute_credit,5)
	if (self.no_of_unique_ips() == 0):
	    return # no connections with peers established yet.
	print "Distributing credit"
	for ipaddr,no_conns in self.unique_ips.items(): # debugging purpose
	    print ipaddr, no_conns # debugging
	print "piece length: ",self.piece_length
	if self.done():
	    print "Acting as seed."
	    self.total_optimistic_rate=self.config['max_upload_rate']
	else:
	    "Acting as a leech"
	    self.total_optimistic_rate=self.config['max_upload_rate']/10
	print "Total optimistic credit = ", self.total_optimistic_rate
	credit_to_each_ip=self.total_optimistic_rate * 5/self.no_of_unique_ips()
	for c in self.connections:
	    u = c.get_upload()
	    print "DEBUG:considering ", c.get_ip()," for optimistic credit."
	    if u.optimistic_credit < self.piece_length: # soft threshold of 1 piece length for optimistic credit
		print "DEBUG: Optimistic credit - ",credit_to_each_ip, " to ", c.get_ip()
		u.optimistic_credit+= credit_to_each_ip / self.connections_sharing_ip(c.get_ip())
	    else:
		print "****DEBUG*****"
		print c.get_ip() , " has reached optimistic credit cap."
		if u.is_choked():
		    print "Choked"
		else:
		    print "Unchoked"
		print "Has ",len(u.buffer)," requests pending."
		print "****END DEBUG*****"
	self._rechoke()
#End Modify - Karthik
##################################################################

    def _snubbed(self, c):
        if self.done():
            return false
        return c.get_download().is_snubbed()

    def _rate(self, c):
        if self.done():
            return c.get_upload().get_rate()
        else:
            return c.get_download().get_rate()

##################################################################
#Modified:Karthik, Sunday, July 27 2003 00:22
#Purpose: rewrite the rechoke routine.
    def _rechoke(self):
        preferred = []
	no_of_uploads=self.config['max_uploads']/2
	print "Rechoking..."
	print "Number of upload slots...",no_of_uploads
        for c in self.connections:
	    u = c.get_upload()
	    total_credit=u.optimistic_credit + u.trade_credit
            if u.is_interested() and total_credit >= u.min_credits_to_unchoke:
                preferred.append((-self._rate(c), c))
        preferred.sort()
# select max_uploads/2 from the sorted list.
        del preferred[no_of_uploads - 1:]
        preferred = [x[1] for x in preferred]
# select remaining max_uploads/2 on round robin basis.
        count=0
	mark=0
	for c in self.connections:
	    mark+=1
	    u=c.get_upload()
	    total_credit=u.optimistic_credit + u.trade_credit
	    print "Total credit : ",total_credit," for ",c.get_ip()
	    if count < no_of_uploads:
		if u.is_interested():
		    if c not in preferred:
			if self.is_first_time_for_free_credit(c) or total_credit>=u.min_credits_to_unchoke:
		    	    preferred.append(c)
		    	    count=count+1
			else:
			    u.choke()
	    else:
		self.connections=self.connections[mark:]+self.connections[:mark]# re order connections for next round robin.
		break
# blindly unchoke all the connections in the preferred list.
	print "DEBUG: preferred list. finally"
	for c in preferred:
	    print c.get_ip()
            u = c.get_upload()
            u.unchoke()
#End Modify - Karthik
##################################################################        

    def connection_made(self, connection, p = None):
        if p is None:
            p = randrange(-2, len(self.connections) + 1)
        self.connections.insert(max(p, 0), connection)
##################################################################
#Modified:Karthik, Saturday, July 26 2003 21:39
#Purpose: unique_ips: update on new connection.
	ip=connection.get_ip()
	if self.unique_ips.has_key(ip):
		self.unique_ips[ip]=self.unique_ips[ip]+1
	else:
		self.unique_ips[ip]=1
#End Modify - Karthik
##################################################################        
	self._rechoke()

##################################################################
#Modified:Karthik, Saturday, July 26 2003 21:52
#Purpose: Added an aditional parameter - ip. of the peer that terminated
    def connection_lost(self, connection):
        self.connections.remove(connection)
#Purpose: unique_ips: update on lost connection.
	ip=connection.get_ip()
	if ip in self.unique_ips.keys():
	    if self.unique_ips[ip]==1:
		print "Removing from unique ips: ", ip
		del self.unique_ips[ip]
	    else:
		print "Decrmenting count from unique ips: ", ip
		self.unique_ips[ip]=self.unique_ips[ip]-1
	print "Unique ips"
	for ipaddr,no_conns in self.unique_ips.items(): # debugging purpose
    	    print ipaddr, no_conns # debugging
#End Modify - Karthik
##################################################################  
        if connection.get_upload().is_interested() and not connection.get_upload().is_choked():
            self._rechoke()

    def interested(self, connection):
        if not connection.get_upload().is_choked():
            self._rechoke()

    def not_interested(self, connection):
        if not connection.get_upload().is_choked():
            self._rechoke()

##################################################################
#Modified:Karthik, Saturday, July 26 2003 21:49
#Purpose: unique_ips: interface - returns no. of connections sharing ip
    def connections_sharing_ip(self,ip):
	if self.unique_ips.has_key(ip):
	    return self.unique_ips[ip]
	else:
	    return 0

#Purpose interface to unique_ips - to return no. of unique ips
    def no_of_unique_ips(self):
	return len(self.unique_ips)
#End Modify - Karthik
##################################################################        

class DummyScheduler:
    def __init__(self):
        self.s = []

    def __call__(self, func, delay):
        self.s.append((func, delay))

class DummyConnection:
    def __init__(self, v = 0):
        self.u = DummyUploader()
        self.d = DummyDownloader(self)
        self.v = v
    
    def get_upload(self):
        return self.u

    def get_download(self):
        return self.d

class DummyDownloader:
    def __init__(self, c):
        self.s = false
        self.c = c

    def is_snubbed(self):
        return self.s

    def get_rate(self):
        return self.c.v

class DummyUploader:
    def __init__(self):
        self.i = false
        self.c = true

    def choke(self):
        if not self.c:
            self.c = true

    def unchoke(self):
        if self.c:
            self.c = false

    def is_choked(self):
        return self.c

    def is_interested(self):
        return self.i

def test_round_robin_with_no_downloads():
    s = DummyScheduler()
    Choker(2, s)
    assert len(s.s) == 1
    assert s.s[0][1] == 10
    s.s[0][0]()
    del s.s[0]
    assert len(s.s) == 1
    assert s.s[0][1] == 10
    s.s[0][0]()
    del s.s[0]
    s.s[0][0]()
    del s.s[0]
    s.s[0][0]()
    del s.s[0]

def test_resort():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection()
    c2 = DummyConnection(1)
    c3 = DummyConnection(2)
    c4 = DummyConnection(3)
    c2.u.i = true
    c3.u.i = true
    choker.connection_made(c1)
    assert not c1.u.c
    choker.connection_made(c2, 1)
    assert not c1.u.c
    assert not c2.u.c
    choker.connection_made(c3, 1)
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c
    c2.v = 2
    c3.v = 1
    choker.connection_made(c4, 1)
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c
    assert not c4.u.c
    choker.connection_lost(c4)
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c
    s.s[0][0]()
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c

def test_interest():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection()
    c2 = DummyConnection(1)
    c3 = DummyConnection(2)
    c2.u.i = true
    c3.u.i = true
    choker.connection_made(c1)
    assert not c1.u.c
    choker.connection_made(c2, 1)
    assert not c1.u.c
    assert not c2.u.c
    choker.connection_made(c3, 1)
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c
    c3.u.i = false
    choker.not_interested(c3)
    assert not c1.u.c
    assert not c2.u.c
    assert not c3.u.c
    c3.u.i = true
    choker.interested(c3)
    assert not c1.u.c
    assert c2.u.c
    assert not c3.u.c
    choker.connection_lost(c3)
    assert not c1.u.c
    assert not c2.u.c

def test_robin_interest():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(1)
    c1.u.i = true
    choker.connection_made(c2)
    assert not c2.u.c
    choker.connection_made(c1, 0)
    assert not c1.u.c
    assert c2.u.c
    c1.u.i = false
    choker.not_interested(c1)
    assert not c1.u.c
    assert not c2.u.c
    c1.u.i = true
    choker.interested(c1)
    assert not c1.u.c
    assert c2.u.c
    choker.connection_lost(c1)
    assert not c2.u.c

def test_skip_not_interested():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(1)
    c3 = DummyConnection(2)
    c1.u.i = true
    c3.u.i = true
    choker.connection_made(c2)
    assert not c2.u.c
    choker.connection_made(c1, 0)
    assert not c1.u.c
    assert c2.u.c
    choker.connection_made(c3, 2)
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f = s.s[0][0]
    f()
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f()
    assert c1.u.c
    assert c2.u.c
    assert not c3.u.c

def test_connection_lost_no_interrupt():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(1)
    c3 = DummyConnection(2)
    c1.u.i = true
    c2.u.i = true
    c3.u.i = true
    choker.connection_made(c1)
    choker.connection_made(c2, 1)
    choker.connection_made(c3, 2)
    f = s.s[0][0]
    f()
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    assert c3.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    assert c3.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    assert c3.u.c
    choker.connection_lost(c3)
    assert c1.u.c
    assert not c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    choker.connection_lost(c2)
    assert not c1.u.c

def test_connection_made_no_interrupt():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(1)
    c3 = DummyConnection(2)
    c1.u.i = true
    c2.u.i = true
    c3.u.i = true
    choker.connection_made(c1)
    choker.connection_made(c2, 1)
    f = s.s[0][0]
    assert not c1.u.c
    assert c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    choker.connection_made(c3, 1)
    assert not c1.u.c
    assert c2.u.c
    assert c3.u.c
    f()
    assert c1.u.c
    assert c2.u.c
    assert not c3.u.c

def test_round_robin():
    s = DummyScheduler()
    choker = Choker(1, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(1)
    c1.u.i = true
    c2.u.i = true
    choker.connection_made(c1)
    choker.connection_made(c2, 1)
    f = s.s[0][0]
    assert not c1.u.c
    assert c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    f()
    assert c1.u.c
    assert not c2.u.c
    f()
    assert not c1.u.c
    assert c2.u.c
    
def test_multi():
    s = DummyScheduler()
    choker = Choker(4, s)
    c1 = DummyConnection(0)
    c2 = DummyConnection(0)
    c3 = DummyConnection(0)
    c4 = DummyConnection(8)
    c5 = DummyConnection(0)
    c6 = DummyConnection(0)
    c7 = DummyConnection(6)
    c8 = DummyConnection(0)
    c9 = DummyConnection(9)
    c10 = DummyConnection(7)
    c11 = DummyConnection(10)
    choker.connection_made(c1, 0)
    choker.connection_made(c2, 1)
    choker.connection_made(c3, 2)
    choker.connection_made(c4, 3)
    choker.connection_made(c5, 4)
    choker.connection_made(c6, 5)
    choker.connection_made(c7, 6)
    choker.connection_made(c8, 7)
    choker.connection_made(c9, 8)
    choker.connection_made(c10, 9)
    choker.connection_made(c11, 10)
    c2.u.i = true
    c4.u.i = true
    c6.u.i = true
    c8.u.i = true
    c10.u.i = true
    c2.d.s = true
    c6.d.s = true
    c8.d.s = true
    s.s[0][0]()
    assert not c1.u.c
    assert not c2.u.c
    assert not c3.u.c
    assert not c4.u.c
    assert not c5.u.c
    assert not c6.u.c
    assert c7.u.c
    assert c8.u.c
    assert c9.u.c
    assert not c10.u.c
    assert c11.u.c
