# Written by Bram Cohen
# see LICENSE.txt for license information

from time import time
true = 1
false = 0

class Measure:
    def __init__(self, max_rate_period, fudge = 1):
        self.max_rate_period = max_rate_period
        self.ratesince = time() - fudge
        self.last = self.ratesince
        self.rate = 0.0
        self.total = 0l

    def update_rate(self, amount):
        self.total += amount
        t = time()
        self.rate = (self.rate * (self.last - self.ratesince) + 
            amount) / (t - self.ratesince)
        self.last = t
        if self.ratesince < t - self.max_rate_period:
            self.ratesince = t - self.max_rate_period

    def get_rate(self):
        self.update_rate(0)
        return self.rate

    def get_rate_noupdate(self):
        return self.rate
####################################################################################
# Modified: Karthik, Saturday, August 02 2003, 10:57
# Purpose: added newrate==0 in the guard to return 0. It is for the case when the user decreases the rate slider to 0.
    def time_until_rate(self, newrate):
        if self.rate <= newrate or newrate ==0:
            return 0
        t = time() - self.ratesince
        return ((self.rate * t) / newrate) - t
# End modify - Karthik
####################################################################################

    def get_total(self):
        return self.total
